#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXBUFF		0x0400

#define	MAXPAT		0x180


int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		buff[MAXBUFF];

	int		patpos[MAXPAT],patlen[MAXPAT];
	int		patdat[32];
	int		c_patdat[16];
	int		patcnt;

	int		width,height;
	int		wb;
	int		x,y;
	int		m,n,i,j,k;
	int		col,colct;
	int		a0,a1,a2,a3,c;
	int		a00,a01,a02,a03,a04,a05,a06,a07;
	int		sft;
	int		filelen;

	if (argc != 3) {
		fprintf(stderr, "Usage: convchara infile outfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	i = 0;
	while ( (c = fgetc(infp)) != EOF) {
		buff[i] = c;
		i ++;
	}
	filelen = i;

	fseek(infp,0,SEEK_SET);

	a0 = fgetc(infp);
	a1 = fgetc(infp);
	for (i = 0;;i ++) {
		a2 = fgetc(infp);
		a3 = fgetc(infp);
		patpos[i] = (a0 + a1*0x100);
		patlen[i] = (a2 + a3*0x100) - (a0 + a1*0x100);
		if (a2 == 0x00 && a3 == 0x00) {
			patlen[i] = 13;
			break;
		}
		a0 = a2;
		a1 = a3;
	}

	patcnt = i;

	for (i = 0;i <= patcnt;i ++) {

		fseek(infp,0x100+patpos[i],SEEK_SET);

		c = fgetc(infp);
		if (c == 0x00) {
			if (patlen[i] != 13) {
				printf("length illigal\n");
				printf("%d %02x %02x %02x\n",i,patpos[i],patlen[i],c);
				exit(1);
			}
		} else {
			if (patlen[i] != 5) {
				printf("length illigal\n");
				printf("%d %02x %02x %02x\n",i,patpos[i],patlen[i],c);
				exit(1);
			}
		}

		for (j = 0;j < 32;j ++) {
			patdat[j] = 0x08;
		}

		if (c == 0x00) {
			col = 0x01;
			colct = 3;
		} else {
			col = c;
			colct = 1;
		}

		for (j = 0;j < colct;j ++ ) {
			for (y = 0;y < 4;y ++) {

				c = fgetc(infp);
				sft = 0x80;
				for (x = 0;x < 8;x ++) {
					if ((sft & c) != 0) {
						patdat[y*8+x+0] |= col;
					}
					sft /= 2;
				}

			}
			col *= 2;
		}

/* hbgԈ */
		for (y = 0;y < 4;y ++) {

//			a00 = patdat[y*8+ 0];
			a01 = patdat[y*8+ 1];
//			a02 = patdat[y*8+ 2];
			a03 = patdat[y*8+ 3];
			a04 = patdat[y*8+ 4];
//			a05 = patdat[y*8+ 5];
			a06 = patdat[y*8+ 6];
//			a07 = patdat[y*8+ 7];

			c_patdat[y*4+0] = a01;
			c_patdat[y*4+1] = a03;
			c_patdat[y*4+2] = a04;
			c_patdat[y*4+3] = a06;

		}

		if (i == 7) {
			c_patdat[ 0] = 0x0e;
			c_patdat[ 1] = 0x0e;
			c_patdat[ 2] = 0x0e;
			c_patdat[ 3] = 0x0a;
			c_patdat[ 4] = 0x0e;
			c_patdat[ 5] = 0x0e;
			c_patdat[ 6] = 0x0e;
			c_patdat[ 7] = 0x0a;
			c_patdat[ 8] = 0x0e;
			c_patdat[ 9] = 0x0e;
			c_patdat[10] = 0x0e;
			c_patdat[11] = 0x0a;
			c_patdat[12] = 0x08;
			c_patdat[13] = 0x0a;
			c_patdat[14] = 0x0a;
			c_patdat[15] = 0x0a;
		}

		if (i == 8) {
			c_patdat[ 0] = 0x0f;
			c_patdat[ 1] = 0x0f;
			c_patdat[ 2] = 0x0f;
			c_patdat[ 3] = 0x09;
			c_patdat[ 4] = 0x0f;
			c_patdat[ 5] = 0x0f;
			c_patdat[ 6] = 0x0f;
			c_patdat[ 7] = 0x09;
			c_patdat[ 8] = 0x0f;
			c_patdat[ 9] = 0x0f;
			c_patdat[10] = 0x0f;
			c_patdat[11] = 0x09;
			c_patdat[12] = 0x08;
			c_patdat[13] = 0x09;
			c_patdat[14] = 0x09;
			c_patdat[15] = 0x09;
		}

		if (i == 9) {
			c_patdat[ 0] = 0x0f;
			c_patdat[ 1] = 0x0f;
			c_patdat[ 2] = 0x0f;
			c_patdat[ 3] = 0x0a;
			c_patdat[ 4] = 0x0f;
			c_patdat[ 5] = 0x0f;
			c_patdat[ 6] = 0x0f;
			c_patdat[ 7] = 0x0a;
			c_patdat[ 8] = 0x0f;
			c_patdat[ 9] = 0x0f;
			c_patdat[10] = 0x0f;
			c_patdat[11] = 0x0a;
			c_patdat[12] = 0x08;
			c_patdat[13] = 0x0a;
			c_patdat[14] = 0x0a;
			c_patdat[15] = 0x0a;
		}

/* t@Cɔf */

		if (patlen[i] == 13) {

			for (y = 0;y < 4;y ++) {
				buff[ 0x101+patpos[i]+y*3+0] = c_patdat[y*4+0];
				buff[ 0x101+patpos[i]+y*3+1] = c_patdat[y*4+1];
				buff[ 0x101+patpos[i]+y*3+2] = c_patdat[y*4+2] | (c_patdat[y*4+3] << 4);
			}

		} else {

			for (y = 0;y < 4;y ++) {
				buff[ 0x101+patpos[i]+y] =
						( (c_patdat[y*4+0] != 0x08) ? 0x80 : 0x00) + 
						( (c_patdat[y*4+1] != 0x08) ? 0x40 : 0x00) + 
						( (c_patdat[y*4+2] != 0x08) ? 0x20 : 0x00) + 
						( (c_patdat[y*4+3] != 0x08) ? 0x10 : 0x00);
			}

		}


	}

	for (i = 0;i < filelen;i ++) {
		fputc(buff[i],outfp);
	}

	fclose(infp);
	fclose(outfp);

	return(0);
}

