;
; Np
;

	relaxed on

Disk_Routine	equ	$0100

Disk_Init	equ	$0106
Disk_Load	equ	$0109
Disk_Change1DD	equ	$0112

DiskRW		equ	$00d0
DISKTABLE	equ	$0403

SETSUBCPU	equ	$003b


	org	$c000

;
; Track#0 Sector#1`
;
	db	"IPL"		; +0
	jr	START		; +3

;
; ZN^ǂݍ݁iROM[`gpj
;
READ_NSEC:
.loop:
	push	af
	ld	a,$01
	or	a
	push	bc
	push	de
	call	$0198		; ZN^ǂݍ
	pop	de
	pop	bc
	inc	d
	inc	c
	pop	af
	dec	a
	jr	nz,.loop
	ret

START:
	xor	a		; hCuԍ-1
	ld	($ed66),a

	ld	bc,$0002	; Breg:gbNԍACreg:ZN^ԍ
	ld	de,$c100	; i[AhX
	ld	a,$01		; ǂݍރZN^
	call	READ_NSEC

	call	CURCLS

	call	DISPTITLE

	call	CURCLS

	ld	c,$04		; CregFZN^ԍihCupǂݏo[`j

	ld	a,($ed5a)	; bit7`0 = Ot#2A#1A#2A#1A"0000"
	bit	4,a
	jr	nz,.fd_in
	ld	c,$07		; CregFZN^ԍiOthCupǂݏo[`j

.fd_in:

;
; fBXNǂݏ[`[hĂ
;
	ld	b,$00		; BregFgbNԍ
	ld	de,$bc00	; i[擪AhX
	ld	a,$03		; ǂݍރZN^
	call	READ_NSEC

;
; 荞ݏȂǂ[hĂ
;
	ld	bc,$000a	; BregFgbNԍACregFZN^ԍ
	ld	de,$bb00	; i[擪AhX
	ld	a,$01		; ǂݍރZN^
	call	READ_NSEC

;
; vOIpf[^[hĂ
;
	ld	bc,$0804	; BregFgbNԍACregFZN^ԍ
	ld	de,$bf00	; i[擪AhX
	ld	a,$01		; ǂݍރZN^
	call	READ_NSEC

	di

	ld	sp,$bb00

;
; VRAMNA
;
	ld	hl,$0000
.lp1:	ld	(hl),$88
	inc	hl
	ld	a,h
	cp	$80
	jr	nz,.lp1

;
; 0x0000`0x7FFF̃Ot
;
	ld	b,$04
	ld	de,$6068
	ld	a,$20
.outlp1:
	ld	c,d
	out	(c),a
	ld	c,e
	out	(c),a
	inc	a
	inc	a
	inc	d
	inc	e
	djnz	.outlp1

	ld	bc,$5aa5
	ld	hl,$0000
	ld	(hl),b
	ld	h,$40
	ld	(hl),c

	ld	h,$00
	ld	a,(hl)
	cp	b
	jr	nz,.ramng
	ld	h,$40
	ld	a,(hl)
	cp	c
	jr	z,.ramok

.ramng:
	ld	de,RAMNG_MSG
	ld	hl,$f000
	call	PNT_MSG
	jr	$

.diskng:
	ld	de,DISKNG_MSG
	ld	hl,$f000
	call	PNT_MSG
	jr	$

.ramok:


;
; OɓǂݏoAfBXNǂݏA荞݂Ȃǂ]
;
	ld	hl,$bb00
	ld	de,$0000
	ld	bc,$0500
	ldir

;
; fBXN[`̏
;

	ld	d,$00
	call	Disk_Init
	jr	c,.diskng

	ld	d,$00
	call	Disk_Change1DD
	jr	c,.diskng

	im	2
	ld	a,$00
	ld	i,a		; 荞݃e[u0x0000`ɐݒ

	ld	a,$ea		; 荞݂VSYNCA^C}ASUB-CPÛ݂ɂ
	out	($fa),a

	ld	a,$02
	out	($93),a		; ʂ

	ld	a,$fb		; 320x200 OtBbN
	out	($c1),a

	ld	a,$e2		; rbg}bv[hɐݒ^y[WO\
	out	($c8),a

	xor	a
	out	($c9),a		; VRAM}bv̐ݒ
	out	($ca),a		; XN[̏
	out	($cb),a		; XN[̏
	out	($cc),a		; XN[̏
	out	($ce),a		; YWiʁj̐ݒ
	out	($cf),a		; YWiʁj̐ݒ

	out	($40),a		; pbg̏
	inc	a
	out	($41),a
	inc	a
	out	($42),a
	inc	a
	out	($43),a

	ld	a,$03
	out	($93),a		; ʂ\

	ld	a,$07
	out	($a0),a		; ~LT[
	ld	a,$bf
	out	($a1),a		; `l`o͂

	ld	a,$08
	out	($a0),a		; `l`
	xor	a
	out	($a1),a

	ei

	ld	a,$05
	call	SETSUBCPU	; ȂЂ炪ȁJ^Jiɂ

	xor	a		; vO#0ǂݍ݋N
	jp	$0103


;
; ʃNAiLN^j
;
CURCLS:
	ld	hl,$f000
	ld	(hl),$20
	inc	hl
	ld	(hl),$0f
	inc	hl
	ld	de,$f000
	ex	de,hl
	ld	bc,40*25*2-1
	ldir
	ret

;
; \
;
PNT_MSG:
.msglp:
	ld	a,(de)
	inc	de
	or	a
	ret	z
	ld	(hl),a
	inc	hl
	inc	hl
	jr	.msglp

;
; ^Cg\
;
DISPTITLE:
	ld	bc,1000/2
	call	WAITTIME

	ld	de,TITLE_MSG
	ld	c,13

.lp2:
	ld	a,39
	sub	c
	ld	b,a

	ld	hl,$f000+40*2*10+39*2

.lp1:
	ld	a,(de)
	or	a
	jr	z,.end
	ld	(hl),a
	inc	hl
	inc	hl
	ld	(hl),' '
	dec	hl
	dec	hl
	dec	hl
	dec	hl

	push	bc
	ld	bc,14/2
	call	WAITTIME
	pop	bc

	djnz	.lp1

	inc	de
	inc	c
	jr	.lp2

.end:
	ld	bc,1000/2
	call	WAITTIME

	ld	de,VER_MSG
	ld	hl,$f000+40*2*12+22*2
	call	PNT_MSG

	ld	bc,4000/2
	call	WAITTIME

	ret

;
; ԑ҂i 2ms ~ BCj
;
WAITTIME:
.lp1:	ld	a,$e2		; 7+1  /  8
.lp2:	dec	a		; 4+1  / 13
	nop			; 4+1  / 18
	jr	nz,.lp2		; 12+1 / 31

	dec	bc
	ld	a,b
	or	c
	jr	nz,.lp1
	ret


TITLE_MSG:
	db	"Phantasie-2",$00

VER_MSG:
	db	"for P6 ver1.1",$00

DISKNG_MSG:
	db	"Disk error",$00

RAMNG_MSG:
	db	"32K",$92,$9c,$de,$8e,$93,$e9		; RQjJ傤
	db	"RAM",$96,$de,$20			; q`lJ
	db	$eb,$e2,$f6,$93,$e3,$de,$9d,$a1,$00	; Ђ悤āJB




	org	$c300
;
; Track#0 Sector#4-6
;

	phase	Disk_Routine

	include	"disk66.z80"	; hCupǂݏo[`

	dephase


	org	$c600
;
; Track#0 Sector#7-9
;

	phase	Disk_Routine

	include	"disk.z80"	; OthCupǂݏo[`

	dephase


	org	$c8ff
	db	$ff


end

